Index: issm/branches/trunk-jpl-damage/src/c/modules/ElementResponsex/ElementResponsex.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ElementResponsex/ElementResponsex.cpp	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ElementResponsex/ElementResponsex.cpp	(revision 12168)
@@ -37,6 +37,8 @@
 
 	/*Broadcast whether we found the element: */
+	#ifdef _HAVE_MPI_
 	MPI_Allreduce ( &found,&sumfound,1,MPI_INT,MPI_SUM,MPI_COMM_WORLD);
 	if(!sumfound)_error_("%s%i%s","could not find material with id",index," to compute ElementResponse");
+	#endif
 
 	/*Ok, we found the element, compute responseocity: */
@@ -46,6 +48,8 @@
 
 	/*Broadcast and plug into response: */
+	#ifdef _HAVE_MPI_
 	MPI_Allreduce ( &cpu_found,&cpu_found,1,MPI_INT,MPI_MAX,MPI_COMM_WORLD);
 	MPI_Bcast(&response,1,MPI_DOUBLE,cpu_found,MPI_COMM_WORLD); 
+	#endif
 
 	*presponse=response;
Index: issm/branches/trunk-jpl-damage/src/c/modules/Exp2Kmlx/Exp2Kmlx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Exp2Kmlx/Exp2Kmlx.cpp	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Exp2Kmlx/Exp2Kmlx.cpp	(revision 12168)
@@ -61,5 +61,5 @@
 /*  read exp file  */
 
-	if (!DomainOutlineRead(&nprof,&pnvert,&pprofx,&pprofy,&closed,filexp,true))
+	if (!DomainOutlineRead(&nprof,&pnvert,&pprofx,&pprofy,&closed,filexp))
 		_error_("Error reading exp file.");
 	_printf_(true,"Exp2Kmlx -- Reading %d exp profiles from file \"%s\".\n",nprof,filexp);
Index: issm/branches/trunk-jpl-damage/src/c/modules/GroundinglineMigrationx/GroundinglineMigrationx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/GroundinglineMigrationx/GroundinglineMigrationx.cpp	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/c/modules/GroundinglineMigrationx/GroundinglineMigrationx.cpp	(revision 12168)
@@ -156,6 +156,10 @@
 		vec_nodes_on_floatingice->Assemble();
 		
+		#ifdef _HAVE_MPI_
 		MPI_Allreduce(&local_nflipped,&nflipped,1,MPI_INT,MPI_SUM,MPI_COMM_WORLD);
 		_printf_(VerboseConvergence(),"   Additional number of vertices allowed to unground: %i\n",nflipped);
+		#else
+		nflipped=local_nflipped;
+		#endif
 
 		/*Avoid leaks: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/IceVolumex/IceVolumex.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/IceVolumex/IceVolumex.cpp	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/c/modules/IceVolumex/IceVolumex.cpp	(revision 12168)
@@ -19,6 +19,10 @@
 		local_ice_volume+=element->IceVolume();
 	}
+	#ifdef _HAVE_MPI_
 	MPI_Reduce(&local_ice_volume,&total_ice_volume,1,MPI_DOUBLE,MPI_SUM,0,MPI_COMM_WORLD );
 	MPI_Bcast(&total_ice_volume,1,MPI_DOUBLE,0,MPI_COMM_WORLD);
+	#else
+	total_ice_volume=local_ice_volume;
+	#endif
 
 	/*Assign output pointers: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/InputConvergencex/InputConvergencex.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/InputConvergencex/InputConvergencex.cpp	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/c/modules/InputConvergencex/InputConvergencex.cpp	(revision 12168)
@@ -30,5 +30,5 @@
 
 	/*In parallel, we need to gather the converged status: */
-	#ifdef _PARALLEL_
+	#ifdef _HAVE_MPI_
 	MPI_Allreduce ( (void*)&num_notconverged,(void*)&total_notconverged,1,MPI_INT,MPI_SUM,MPI_COMM_WORLD);
 	num_notconverged=total_notconverged;
Index: issm/branches/trunk-jpl-damage/src/c/modules/InterpFromMeshToMesh2dx/InterpFromMeshToMesh2dx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/InterpFromMeshToMesh2dx/InterpFromMeshToMesh2dx.cpp	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/c/modules/InterpFromMeshToMesh2dx/InterpFromMeshToMesh2dx.cpp	(revision 12168)
@@ -14,5 +14,5 @@
 
 int InterpFromMeshToMesh2dx(double** pdata_interp,double* index_data,double* x_data,double* y_data,int nods_data,int nels_data,
-			double* data,int data_rows,int data_cols,double* x_interp,double* y_interp,int nods_interp,double* default_values,int num_default_values, Contour** contours, int numcontours){
+			double* data,int data_rows,int data_cols,double* x_interp,double* y_interp,int nods_interp,double* default_values,int num_default_values, DataSet* contours){
 	
 	/*Output*/
@@ -36,5 +36,4 @@
 	bool   skip_bamg=false;
 
-
 	/*Checks*/
 	if (data_cols<=0){
@@ -50,5 +49,5 @@
 	/*If default values supplied, figure out which nodes are inside the contour, including the border of the contour: */
 	if(num_default_values){
-		ContourToNodesx( &vec_incontour,x_interp,y_interp,nods_interp,contours,numcontours,1);
+		ContourToNodesx( &vec_incontour,x_interp,y_interp,nods_interp,contours,1);
 		incontour=vec_incontour->ToMPISerial();
 	}
Index: issm/branches/trunk-jpl-damage/src/c/modules/InterpFromMeshToMesh2dx/InterpFromMeshToMesh2dx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/InterpFromMeshToMesh2dx/InterpFromMeshToMesh2dx.h	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/c/modules/InterpFromMeshToMesh2dx/InterpFromMeshToMesh2dx.h	(revision 12168)
@@ -10,5 +10,5 @@
 /* local prototypes: */
 int InterpFromMeshToMesh2dx(double** pdata_interp,double* index_data,double* x_data,double* y_data,int nods_data,int nels_data,
-			double* data,int data_rows,int data_cols,double* x_interp,double* y_interp,int nods_interp,double* default_values,int num_default_values,Contour** contours, int numcontours );
+			double* data,int data_rows,int data_cols,double* x_interp,double* y_interp,int nods_interp,double* default_values,int num_default_values,DataSet* contours);
 
 #endif
Index: issm/branches/trunk-jpl-damage/src/c/modules/Krigingx/Krigingx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Krigingx/Krigingx.cpp	(revision 12168)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Krigingx/Krigingx.cpp	(revision 12168)
@@ -0,0 +1,22 @@
+/*!\file:  Kriging.cpp
+ * \brief  "c" core code for Kriging
+ */ 
+
+#include "./Krigingx.h"
+#include "../../shared/shared.h"
+#include "../../include/include.h"
+#include "../../toolkits/toolkits.h"
+#include "../../objects/objects.h"
+#include "../modules.h"
+
+int Krigingx(double** ppredictions,double* x, double* y, double* observations, int n_obs,double* x_interp,double* y_interp,int n_interp){
+
+	/*output*/
+	double *predictions = NULL;
+
+	/*Allocate output*/
+	predictions=(double*)xmalloc(n_interp*sizeof(double));
+
+	/*Assign output pointer*/
+	*ppredictions=predictions;
+}
Index: issm/branches/trunk-jpl-damage/src/c/modules/Krigingx/Krigingx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Krigingx/Krigingx.h	(revision 12168)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Krigingx/Krigingx.h	(revision 12168)
@@ -0,0 +1,15 @@
+/*!\file Kriging.h
+ * \brief: header file for Kriging
+ */
+
+#ifndef _KRIGINGX_H
+#define _KRIGINGX_H
+
+#include "../../objects/objects.h"
+#include "../../toolkits/toolkits.h"
+
+
+int Krigingx(double** ppredictions,double* x, double* y, double* observations, int n_obs,double* x_interp,double* y_interp,int n_interp);
+
+#endif /* _KRIGINGX_H */
+
Index: issm/branches/trunk-jpl-damage/src/c/modules/MassFluxx/MassFluxx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/MassFluxx/MassFluxx.cpp	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/c/modules/MassFluxx/MassFluxx.cpp	(revision 12168)
@@ -59,5 +59,5 @@
 	}
 
-	#ifdef _PARALLEL_
+	#ifdef _HAVE_MPI_
 	MPI_Allreduce ( (void*)&mass_flux,(void*)&all_mass_flux,1,MPI_DOUBLE,MPI_SUM,MPI_COMM_WORLD);
 	mass_flux=all_mass_flux;
Index: issm/branches/trunk-jpl-damage/src/c/modules/MaxAbsVxx/MaxAbsVxx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/MaxAbsVxx/MaxAbsVxx.cpp	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/c/modules/MaxAbsVxx/MaxAbsVxx.cpp	(revision 12168)
@@ -31,6 +31,6 @@
 	}
 
-	#ifdef _PARALLEL_
 	/*Figure out maximum across the cluster: */
+	#ifdef _HAVE_MPI_
 	MPI_Reduce (&maxabsvx,&node_maxabsvx,1,MPI_DOUBLE,MPI_MAX,0,MPI_COMM_WORLD );
 	MPI_Bcast(&node_maxabsvx,1,MPI_DOUBLE,0,MPI_COMM_WORLD);   
Index: issm/branches/trunk-jpl-damage/src/c/modules/MaxAbsVyx/MaxAbsVyx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/MaxAbsVyx/MaxAbsVyx.cpp	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/c/modules/MaxAbsVyx/MaxAbsVyx.cpp	(revision 12168)
@@ -32,6 +32,6 @@
 	}
 
-	#ifdef _PARALLEL_
 	/*Figure out maximum across the cluster: */
+	#ifdef _HAVE_MPI_
 	MPI_Reduce (&maxabsvy,&node_maxabsvy,1,MPI_DOUBLE,MPI_MAX,0,MPI_COMM_WORLD );
 	MPI_Bcast(&node_maxabsvy,1,MPI_DOUBLE,0,MPI_COMM_WORLD);   
Index: issm/branches/trunk-jpl-damage/src/c/modules/MaxAbsVzx/MaxAbsVzx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/MaxAbsVzx/MaxAbsVzx.cpp	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/c/modules/MaxAbsVzx/MaxAbsVzx.cpp	(revision 12168)
@@ -31,6 +31,6 @@
 	}
 
-	#ifdef _PARALLEL_
 	/*Figure out minimum across the cluster: */
+	#ifdef _HAVE_MPI_
 	MPI_Reduce (&maxabsvz,&node_maxabsvz,1,MPI_DOUBLE,MPI_MAX,0,MPI_COMM_WORLD );
 	MPI_Bcast(&node_maxabsvz,1,MPI_DOUBLE,0,MPI_COMM_WORLD);   
Index: issm/branches/trunk-jpl-damage/src/c/modules/MaxVelx/MaxVelx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/MaxVelx/MaxVelx.cpp	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/c/modules/MaxVelx/MaxVelx.cpp	(revision 12168)
@@ -32,6 +32,6 @@
 	}
 
-	#ifdef _PARALLEL_
 	/*Figure out maximum across the cluster: */
+	#ifdef _HAVE_MPI_
 	MPI_Reduce (&maxvel,&node_maxvel,1,MPI_DOUBLE,MPI_MAX,0,MPI_COMM_WORLD );
 	MPI_Bcast(&node_maxvel,1,MPI_DOUBLE,0,MPI_COMM_WORLD);   
Index: issm/branches/trunk-jpl-damage/src/c/modules/MaxVxx/MaxVxx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/MaxVxx/MaxVxx.cpp	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/c/modules/MaxVxx/MaxVxx.cpp	(revision 12168)
@@ -31,6 +31,6 @@
 	}
 
-	#ifdef _PARALLEL_
 	/*Figure out minimum across the cluster: */
+	#ifdef _HAVE_MPI_
 	MPI_Reduce (&maxvx,&node_maxvx,1,MPI_DOUBLE,MPI_MAX,0,MPI_COMM_WORLD );
 	MPI_Bcast(&node_maxvx,1,MPI_DOUBLE,0,MPI_COMM_WORLD);   
Index: issm/branches/trunk-jpl-damage/src/c/modules/MaxVyx/MaxVyx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/MaxVyx/MaxVyx.cpp	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/c/modules/MaxVyx/MaxVyx.cpp	(revision 12168)
@@ -31,6 +31,6 @@
 	}
 
-	#ifdef _PARALLEL_
 	/*Figure out minimum across the cluster: */
+	#ifdef _HAVE_MPI_
 	MPI_Reduce (&maxvy,&node_maxvy,1,MPI_DOUBLE,MPI_MAX,0,MPI_COMM_WORLD );
 	MPI_Bcast(&node_maxvy,1,MPI_DOUBLE,0,MPI_COMM_WORLD);   
Index: issm/branches/trunk-jpl-damage/src/c/modules/MaxVzx/MaxVzx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/MaxVzx/MaxVzx.cpp	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/c/modules/MaxVzx/MaxVzx.cpp	(revision 12168)
@@ -32,6 +32,6 @@
 	}
 
-	#ifdef _PARALLEL_
 	/*Figure out minimum across the cluster: */
+	#ifdef _HAVE_MPI_
 	MPI_Reduce (&maxvz,&node_maxvz,1,MPI_DOUBLE,MPI_MAX,0,MPI_COMM_WORLD );
 	MPI_Bcast(&node_maxvz,1,MPI_DOUBLE,0,MPI_COMM_WORLD);   
Index: issm/branches/trunk-jpl-damage/src/c/modules/MeshPartitionx/MeshPartitionx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/MeshPartitionx/MeshPartitionx.cpp	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/c/modules/MeshPartitionx/MeshPartitionx.cpp	(revision 12168)
@@ -42,5 +42,7 @@
 		/*Partition using Metis:*/
 		if (num_procs>1){
+			#ifdef _HAVE_METIS_
 			METIS_PartMeshNodalPatch(&numberofelements,&numberofnodes, index, &etype, &numflag, &num_procs, &edgecut, epart, npart);
+			#endif
 		}
 		else if (num_procs==1){
@@ -67,5 +69,7 @@
 		/*Partition using Metis:*/
 		if (num_procs>1){
+			#ifdef _HAVE_METIS_
 			METIS_PartMeshNodalPatch(&numberofelements2d,&numberofnodes2d, index2d, &etype2d, &numflag, &num_procs, &edgecut, epart2d, npart2d);
+			#endif
 		}
 		else if (num_procs==1){
Index: issm/branches/trunk-jpl-damage/src/c/modules/MeshProfileIntersectionx/SegmentIntersect.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/MeshProfileIntersectionx/SegmentIntersect.cpp	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/c/modules/MeshProfileIntersectionx/SegmentIntersect.cpp	(revision 12168)
@@ -6,5 +6,5 @@
 int SegmentIntersect(double* palpha, double* pbeta, double* x1, double* y1, double* x2, double* y2){
 
-	/*See ISSM_TIER/src/m/utils/Geometry/SegIntersect.m for matlab routine from which we take this routine: */
+	/*See ISSM_DIR/src/m/utils/Geometry/SegIntersect.m for matlab routine from which we take this routine: */
 
 	/*output: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/MinVelx/MinVelx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/MinVelx/MinVelx.cpp	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/c/modules/MinVelx/MinVelx.cpp	(revision 12168)
@@ -32,6 +32,6 @@
 	}
 
-	#ifdef _PARALLEL_
 	/*Figure out minimum across the cluster: */
+	#ifdef _HAVE_MPI_
 	MPI_Reduce (&minvel,&node_minvel,1,MPI_DOUBLE,MPI_MIN,0,MPI_COMM_WORLD );
 	MPI_Bcast(&node_minvel,1,MPI_DOUBLE,0,MPI_COMM_WORLD);   
Index: issm/branches/trunk-jpl-damage/src/c/modules/MinVxx/MinVxx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/MinVxx/MinVxx.cpp	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/c/modules/MinVxx/MinVxx.cpp	(revision 12168)
@@ -31,6 +31,6 @@
 	}
 
-	#ifdef _PARALLEL_
 	/*Figure out minimum across the cluster: */
+	#ifdef _HAVE_MPI_
 	MPI_Reduce (&minvx,&node_minvx,1,MPI_DOUBLE,MPI_MIN,0,MPI_COMM_WORLD );
 	MPI_Bcast(&node_minvx,1,MPI_DOUBLE,0,MPI_COMM_WORLD);   
Index: issm/branches/trunk-jpl-damage/src/c/modules/MinVyx/MinVyx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/MinVyx/MinVyx.cpp	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/c/modules/MinVyx/MinVyx.cpp	(revision 12168)
@@ -31,6 +31,6 @@
 	}
 
-	#ifdef _PARALLEL_
 	/*Figure out minimum across the cluster: */
+	#ifdef _HAVE_MPI_
 	MPI_Reduce (&minvy,&node_minvy,1,MPI_DOUBLE,MPI_MIN,0,MPI_COMM_WORLD );
 	MPI_Bcast(&node_minvy,1,MPI_DOUBLE,0,MPI_COMM_WORLD);   
Index: issm/branches/trunk-jpl-damage/src/c/modules/MinVzx/MinVzx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/MinVzx/MinVzx.cpp	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/c/modules/MinVzx/MinVzx.cpp	(revision 12168)
@@ -31,6 +31,6 @@
 	}
 
-	#ifdef _PARALLEL_
 	/*Figure out minimum across the cluster: */
+	#ifdef _HAVE_MPI_
 	MPI_Reduce (&minvz,&node_minvz,1,MPI_DOUBLE,MPI_MIN,0,MPI_COMM_WORLD );
 	MPI_Bcast(&node_minvz,1,MPI_DOUBLE,0,MPI_COMM_WORLD);   
Index: issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/ElementsAndVerticesPartitioning.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/ElementsAndVerticesPartitioning.cpp	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ModelProcessorx/ElementsAndVerticesPartitioning.cpp	(revision 12168)
@@ -63,5 +63,4 @@
 	else elements_width=6; //penta elements
 
-	#ifdef _PARALLEL_
 	/*Determine parallel partitioning of elements: we use Metis for now. First load the data, then partition*/
 	if(dim==2){
@@ -79,9 +78,4 @@
 	xfree((void**)&elements);
 	xfree((void**)&elements2d);
-
-	#else
-	/*In serial mode, epart is full of 0: all elements belong to cpu 0: */
-	epart=(int*)xcalloc(numberofelements,sizeof(int));
-	#endif
 
 	/*Deal with rifts, they have to be included into one partition only, not several: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/NodalValuex/NodalValuex.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/NodalValuex/NodalValuex.cpp	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/c/modules/NodalValuex/NodalValuex.cpp	(revision 12168)
@@ -36,10 +36,16 @@
 
 	/*Broadcast whether we found the element: */
+	#ifdef _HAVE_MPI_
 	MPI_Allreduce ( &found,&sumfound,1,MPI_INT,MPI_SUM,MPI_COMM_WORLD);
 	if(!sumfound)_error_("%s%i%s%s","could not find element with vertex with id",index," to compute nodal value ",EnumToStringx(natureofdataenum));
+	#endif
 
 	/*Broadcast and plug into response: */
+	#ifdef _HAVE_MPI_
 	MPI_Allreduce ( &cpu_found,&cpu_found,1,MPI_INT,MPI_MAX,MPI_COMM_WORLD);
 	MPI_Bcast(&value,1,MPI_DOUBLE,cpu_found,MPI_COMM_WORLD); 
+	#else
+	value=cpu_found;
+	#endif
 
 	*pnodalvalue=value;
Index: issm/branches/trunk-jpl-damage/src/c/modules/OutputResultsx/OutputResultsx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/OutputResultsx/OutputResultsx.cpp	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/c/modules/OutputResultsx/OutputResultsx.cpp	(revision 12168)
@@ -16,9 +16,5 @@
 #include "../../objects/objects.h"
 		
-#if defined(_HAVE_MATLAB_) && defined(_SERIAL_)
-void OutputResultsx(mxArray** pdataref, Elements* elements, Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,Results* results){
-#else 
 void OutputResultsx(                    Elements* elements, Nodes* nodes, Vertices* vertices, Loads* loads, Materials* materials, Parameters* parameters,Results* results){
-#endif
 
 	extern int  my_rank;
@@ -31,11 +27,4 @@
 	bool        dakota_analysis         = false;
 	
-	#if defined(_HAVE_MATLAB_) && defined(_SERIAL_)
-	const char **fnames      = NULL;
-	mwSize       onebyone[2] = {0,0};
-	mwSize       ndim        = 2;
-	int          nfields=0;
-	#endif
-
 	/*retrieve parameters: */
 	parameters->FindParam(&dakota_analysis,QmuIsdakotaEnum);
@@ -43,7 +32,4 @@
 	if(dakota_analysis){
 		//no need to output anything, Dakota analysis has different outputs
-		#if defined(_HAVE_MATLAB_) && defined(_SERIAL_)
-		*pdataref=mxCreateStructArray( ndim,onebyone,nfields,fnames);
-		#endif
 		return; 
 	}
@@ -56,5 +42,4 @@
 	/*Results do not include the type of solution being run	. In parallel, we output results to a filename, 
 	 *therefore, we need to include the solutiontype into the filename: */
-	#ifdef _PARALLEL_
 	if(my_rank==0){
 		parameters->FindParam(&solutiontype,SolutionTypeEnum);
@@ -88,26 +73,19 @@
 		parameters->SetParam(fid,OutputFilePointerEnum);
 	}
-	#endif
 
-	/*Write results to disk (in parallel), or to memory (in serial mode): */
-	#if defined(_HAVE_MATLAB_) && defined(_SERIAL_)
-		results->Write(pdataref);
-	#else
-		results->Write(parameters);
-	#endif
+	/*Write results to disk: */
+	results->Write(parameters);
 
 	/*Delete and reinitialize results, in parallel: */
-	#ifdef _PARALLEL_
-		results->clear();
+	results->clear();
 
-		/*Close output file? :*/
-		/*WARNING: issm.cpp is taking care of it for now (quick fix)
-		if((step==1) && (time==0)){
-			if(io_gather){
-				if(my_rank==0) pfclose(fid,outputfilename);
-			}
-			else pfclose(fid,cpu_outputfilename);
-		}
-		*/
-	#endif
+	/*Close output file? :*/
+	/*WARNING: issm.cpp is taking care of it for now (quick fix)
+	  if((step==1) && (time==0)){
+	  if(io_gather){
+	  if(my_rank==0) pfclose(fid,outputfilename);
+	  }
+	  else pfclose(fid,cpu_outputfilename);
+	  }
+	*/
 }
Index: issm/branches/trunk-jpl-damage/src/c/modules/OutputResultsx/OutputResultsx.h
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/OutputResultsx/OutputResultsx.h	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/c/modules/OutputResultsx/OutputResultsx.h	(revision 12168)
@@ -14,10 +14,5 @@
 #include "../../Container/Container.h"
 
-#if defined(_HAVE_MATLAB_) && defined(_SERIAL_)
-#include <mex.h>
-void OutputResultsx(mxArray** pdataref, Elements* elements, Nodes* nodes, Vertices* vertices, Loads* loads,  Materials* materials, Parameters* parameters, Results* results);
-#else
 void OutputResultsx(Elements* elements, Nodes* nodes, Vertices* vertices, Loads* loads,  Materials* materials, Parameters* parameters, Results* results);
-#endif
 
 #endif  /* _OUTPUTRESULTS_H */
Index: issm/branches/trunk-jpl-damage/src/c/modules/ParsePetscOptionsx/ParsePetscOptionsx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/ParsePetscOptionsx/ParsePetscOptionsx.cpp	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/c/modules/ParsePetscOptionsx/ParsePetscOptionsx.cpp	(revision 12168)
@@ -92,6 +92,6 @@
 	}
 
-	#ifdef _PARALLEL_
 	/*Ok, broadcast to other cpus: */
+ 	#ifdef _HAVE_MPI_
 	MPI_Bcast(&numanalyses,1,MPI_INT,0,MPI_COMM_WORLD);
 	if(my_rank!=0){
@@ -100,4 +100,5 @@
 	}
 	MPI_Bcast(analyses,numanalyses,MPI_DOUBLE,0,MPI_COMM_WORLD);
+	#endif
 	for(i=0;i<numanalyses;i++){
 		char* string=strings[i];
@@ -106,10 +107,11 @@
 		}
 		if(my_rank==0)stringlength=(strlen(string)+1)*sizeof(char);
+		#ifdef _HAVE_MPI_
 		MPI_Bcast(&stringlength,1,MPI_INT,0,MPI_COMM_WORLD);
 		if(my_rank!=0)string=(char*)xmalloc(stringlength);
 		MPI_Bcast(string,stringlength,MPI_CHAR,0,MPI_COMM_WORLD);
 		if(my_rank!=0)strings[i]=string;
+		#endif
 	}
-	#endif
 
 	/*Ok, out of strings and analyses and numanalyses, create parameters, and plug them into parameters container: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/PositiveDegreeDayx/PositiveDegreeDayx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/PositiveDegreeDayx/PositiveDegreeDayx.cpp	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/c/modules/PositiveDegreeDayx/PositiveDegreeDayx.cpp	(revision 12168)
@@ -11,11 +11,100 @@
 
 void PositiveDegreeDayx(Elements* elements,Nodes* nodes, Vertices* vertices,Loads* loads,Materials* materials, Parameters* parameters){
-	
-	Element* element = NULL;
 
-	for(int i=0;i<elements->Size();i++){
-		element=(Element*)elements->GetObjectByOffset(i);
-		element->PositiveDegreeDay();
-	}
+// void PositiveDegreeDayx(hd,vTempsea,vPrec,agd,Tsurf,ni){
+//    note "v" prefix means 12 monthly means, ie time dimension
+//    INPUT parameters: ni: working size of arrays
+//    INPUT: surface elevation (m): hd(NA)
+//    monthly mean surface sealevel temperature (degrees C): vTempsea(NA
+//    ,NTIME) 
+//    monthly mean precip rate (m/yr water equivalent): vPrec(NA,NTIME)
+//    OUTPUT: mass-balance (m/yr ice): agd(NA)
+//    mean annual surface temperature (degrees C): Tsurf(NA)
 
+  int    i, it, jj, itm;
+  double DT = 0.02, sigfac, snormfac;
+  double signorm = 5.5;      // signorm : sigma of the temperature distribution for a normal day 
+  double siglim;       // sigma limit for the integration which is equal to 2.5 sigmanorm
+  double signormc;     // sigma of the temperature distribution for cloudy day
+  double siglimc=0, siglim0, siglim0c;
+  double tstep, tsint, tint, tstepc;
+  int    NPDMAX = 1504, NPDCMAX = 1454;
+  //double pdds[NPDMAX]={0}; 
+  //double pds[NPDCMAX]={0};
+  double pddt, pd ; // pd : snow/precip fraction, precipitation falling as snow
+  double PDup, PDCUT = 2.0;    // PDcut: rain/snow cutoff temperature (C)
+  double tstar; // monthly mean surface temp
+  
+  double* pdds=NULL; 
+  double* pds=NULL; 
+  Element* element = NULL;
+  
+  pdds=(double*)xmalloc(NPDMAX*sizeof(double)+1); 
+  pds=(double*)xmalloc(NPDCMAX*sizeof(double)+1); 
+  
+  
+  // PDD constant
+  siglim = 2.5*signorm; 
+  
+  // initialize PDD (creation of a lookup table)
+  tstep = 0.1;
+  tsint = tstep*0.5;
+  sigfac = -1.0/(2.0*pow(signorm,2));
+  snormfac = 1.0/(signorm*sqrt(2.0*acos(-1.0)));
+  siglim = 2.5*signorm;
+  itm = (int)(2*siglim/DT + 1.5);
+  
+  if (itm >= NPDMAX){
+    printf("increase NPDMAX in massBalance.cpp\n");
+    exit (1);
+      }
+  for (it = 0; it < itm; it++){  
+    //    tstar = REAL(it)*DT-siglim;
+    tstar = it*DT-siglim;
+    tint = tsint;
+    pddt = 0;
+    for ( jj = 0; jj < 600; jj++){
+      if (tint > (tstar+siglim)){break;}
+      pddt = pddt + tint*exp(sigfac*(pow((tint-tstar),2)))*tstep;
+      tint = tint+tstep;
+    }
+    pdds[it] = pddt*snormfac;
+  }
+  pdds[itm+1] = siglim + DT;
+  
+  //*********compute PD(T) : snow/precip fraction. precipitation falling as snow
+  tstepc = 0.1;
+  tsint = PDCUT-tstepc*0.5;
+  signormc = signorm - 0.5;
+  sigfac = -1.0/(2.0*pow(signormc,2));
+  snormfac = 1.0/(signormc*sqrt(2.0*acos(-1.0)));
+  siglimc = 2.5*signormc ;
+  itm = (int)((PDCUT+2.*siglimc)/DT + 1.5);
+  if (itm >= NPDCMAX){
+    printf("'increase NPDCMAX in p35com'\n");
+    exit (1);
+      }
+  for (it = 0; it < itm; it++ ){
+    tstar = it*DT-siglimc;
+    //    tstar = REAL(it)*DT-siglimc;
+    tint = tsint;          // start against upper bound
+    pd = 0;
+    for (jj = 0; jj < 600; jj++){
+      if (tint<(tstar-siglimc)) {break;}
+      pd = pd + exp(sigfac*(pow((tint-tstar),2)))*tstepc;
+      tint = tint-tstepc;
+    }
+    pds[it] = pd*snormfac;  // gaussian integral lookup table for snow fraction
+  }
+  pds[itm+1] = 0;
+  //     *******END initialize PDD
+  
+  for(i=0;i<elements->Size();i++){
+    element=(Element*)elements->GetObjectByOffset(i);
+    element->PositiveDegreeDay(pdds,pds,signorm);
+  }
+  /*free ressouces: */
+  xfree((void**)&pdds);
+  xfree((void**)&pds);
+  
 }
Index: issm/branches/trunk-jpl-damage/src/c/modules/RheologyBbarAbsGradientx/RheologyBbarAbsGradientx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/RheologyBbarAbsGradientx/RheologyBbarAbsGradientx.cpp	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/c/modules/RheologyBbarAbsGradientx/RheologyBbarAbsGradientx.cpp	(revision 12168)
@@ -27,7 +27,9 @@
 
 	/*Sum all J from all cpus of the cluster:*/
+	#ifdef _HAVE_MPI_
 	MPI_Reduce (&J,&J_sum,1,MPI_DOUBLE,MPI_SUM,0,MPI_COMM_WORLD );
 	MPI_Bcast(&J_sum,1,MPI_DOUBLE,0,MPI_COMM_WORLD);
 	J=J_sum;
+	#endif
 
 	/*Assign output pointers: */
Index: issm/branches/trunk-jpl-damage/src/c/modules/Solverx/Solverx.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Solverx/Solverx.cpp	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Solverx/Solverx.cpp	(revision 12168)
@@ -34,8 +34,4 @@
 
 		/*In serial mode, the Petsc Options database has not been initialized properly: */
-		#ifdef _SERIAL_
-		parameters->FindParam(&analysis_type,AnalysisTypeEnum);
-		PetscOptionsFromAnalysis(parameters,analysis_type);
-		#endif
 
 		SolverxPetsc(&uf_vector,Kff->matrix,pf->vector,uf0_vector,df_vector,parameters);
Index: issm/branches/trunk-jpl-damage/src/c/modules/Solverx/SolverxPetsc.cpp
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/modules/Solverx/SolverxPetsc.cpp	(revision 12167)
+++ issm/branches/trunk-jpl-damage/src/c/modules/Solverx/SolverxPetsc.cpp	(revision 12168)
@@ -43,5 +43,4 @@
 	#endif
 
-
 	/*Display message*/
 	_printf_(VerboseModule(),"   Solving\n");
@@ -52,5 +51,5 @@
 	#endif
 
-	/*First, check that f-set is not NULL, i.e. model is fully constrained: {{{*/
+	/*First, check that f-set is not NULL, i.e. model is fully constrained:*/ 
 	_assert_(Kff);
 	MatGetSize(Kff,&global_m,&global_n); _assert_(global_m==global_m);
@@ -58,6 +57,6 @@
 		*puf=NULL; return;
 	}
-	/*}}}*/
-	/*Initial guess logic here: {{{1*/
+
+	/*Initial guess */
 	/*Now, check that we are not giving an initial guess to the solver, if we are running a direct solver: */
 	#if _PETSC_MAJOR_ >= 3 
@@ -74,54 +73,23 @@
 		MatGetLocalSize(Kff,&local_m,&local_n);uf=NewVec(local_n,fromlocalsize);
 	}
-	/*}}}*/
-	/*Process petsc options to see if we are using special types of external solvers: {{{1*/
+
+	/*Process petsc options to see if we are using special types of external solvers*/
 	PetscOptionsDetermineSolverType(&solver_type);
 
-	/*In serial mode, the matrices have been loaded as MPIAIJ or AIJ matrices. 
-	 We need to convert them if we are going to run the solvers successfully: */
-	#ifdef _SERIAL_
-	#if _PETSC_MAJOR_ == 2 
-	if (solver_type==MUMPSPACKAGE_LU){
-		/*Convert Kff to MATTAIJMUMPS: */
-		MatConvert(Kff,MATAIJMUMPS,MAT_REUSE_MATRIX,&Kff);
+	/*Check the solver is available*/
+	if(solver_type==MUMPSPACKAGE_LU || solver_type==MUMPSPACKAGE_CHOL){
+		#if _PETSC_MAJOR_ >=3
+			#ifndef _HAVE_MUMPS_
+			_error_("requested MUMPS solver, which was not compiled into ISSM!\n");
+			#endif
+		#endif
 	}
-	if (solver_type==MUMPSPACKAGE_CHOL){
-		/*Convert Kff to MATTSBAIJMUMPS: */
-		MatConvert(Kff,MATSBAIJMUMPS,MAT_REUSE_MATRIX,&Kff);
-	}
-	if (solver_type==SPOOLESPACKAGE_LU){
-		/*Convert Kff to MATTSBAIJMUMPS: */
-		MatConvert(Kff,MATAIJSPOOLES,MAT_REUSE_MATRIX,&Kff);
-	}
-	if (solver_type==SPOOLESPACKAGE_CHOL){
-		/*Convert Kff to MATTSBAIJMUMPS: */
-		MatConvert(Kff,MATSBAIJSPOOLES,MAT_REUSE_MATRIX,&Kff);
-	}
-	if (solver_type==SUPERLUDISTPACKAGE){
-		/*Convert Kff to MATTSBAIJMUMPS: */
-		MatConvert(Kff,MATSUPERLU_DIST,MAT_REUSE_MATRIX,&Kff);
-	}
-	if (solver_type==StokesSolverEnum){
-		_error_("Petsc 2 does not support multi-physics solvers");
-	}
-	#endif
-	#endif
-	/*}}}*/
-	/*Check the solver is available: {{{1*/
-	if(solver_type==MUMPSPACKAGE_LU || solver_type==MUMPSPACKAGE_CHOL){
-	#if _PETSC_MAJOR_ >=3
-		#ifndef _HAVE_MUMPS_
-		_error_("requested MUMPS solver, which was not compiled into ISSM!\n");
-		#endif
 
-	#endif
-	}
-	/*}}}*/
-	/*Prepare solver:{{{1*/
+	/*Prepare solver*/
 	KSPCreate(MPI_COMM_WORLD,&ksp);
 	KSPSetOperators(ksp,Kff,Kff,DIFFERENT_NONZERO_PATTERN);
 	KSPSetFromOptions(ksp);
 
-	#if defined(_SERIAL_) && _PETSC_MAJOR_==3
+	#if _PETSC_MAJOR_==3
 	/*Specific solver?: */
 	KSPGetPC(ksp,&pc);
@@ -133,7 +101,5 @@
 		#endif
 	}
-	#endif
 
-	#if defined(_PARALLEL_) && _PETSC_MAJOR_==3
 	/*Stokes: */
 	if (solver_type==StokesSolverEnum){
@@ -155,16 +121,15 @@
 	#endif
 
-	/*}}}*/
-	/*If there is an initial guess for the solution, use it, except if we are using the MUMPS direct solver, where any initial guess will crash Petsc: {{{1*/
+	/*If there is an initial guess for the solution, use it
+	 * except if we are using the MUMPS direct solver
+	 * where any initial guess will crash Petsc*/
 	if (uf0){
-		if( (solver_type!=MUMPSPACKAGE_LU) && (solver_type!=MUMPSPACKAGE_CHOL) && (solver_type!=SPOOLESPACKAGE_LU) && (solver_type!=SPOOLESPACKAGE_CHOL) && (solver_type!=SUPERLUDISTPACKAGE)){
+		if((solver_type!=MUMPSPACKAGE_LU) && (solver_type!=MUMPSPACKAGE_CHOL) && (solver_type!=SPOOLESPACKAGE_LU) && (solver_type!=SPOOLESPACKAGE_CHOL) && (solver_type!=SUPERLUDISTPACKAGE)){
 			KSPSetInitialGuessNonzero(ksp,PETSC_TRUE);
 		}
 	}
-	/*}}}*/
-	
-	if(VerboseSolver())KSPView(ksp,PETSC_VIEWER_STDOUT_WORLD);
 
 	/*Solve: */
+	if(VerboseSolver())KSPView(ksp,PETSC_VIEWER_STDOUT_WORLD);
 	KSPSolve(ksp,pf,uf);
 	
